// ##### ENDFILE "MousePointerShapeChangedEventWrap.cpp"


// ##### BEGINFILE "KeyboardLedsChangedEventWrap.cpp"
/** @file
 * VirtualBox API class wrapper code for IKeyboardLedsChangedEvent.
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl
 * Generator: src/VBox/Main/idl/apiwrap-server.xsl
 */

/**
 * Copyright (C) 2010-2016 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */

#define LOG_GROUP_MAIN_OVERRIDE LOG_GROUP_MAIN_KEYBOARDLEDSCHANGEDEVENT

#include "KeyboardLedsChangedEventWrap.h"
#include "Logging.h"
#ifdef VBOX_WITH_DTRACE_R3_MAIN
# include "dtrace/VBoxAPI.h"
#endif

DEFINE_EMPTY_CTOR_DTOR(KeyboardLedsChangedEventWrap)

//
// IEvent properties
//

STDMETHODIMP KeyboardLedsChangedEventWrap::COMGETTER(Type)(VBoxEventType_T *aType)
{
    LogRelFlow(("{%p} %s: enter aType=%p\n", this, "KeyboardLedsChangedEvent::getType", aType));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aType);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_TYPE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getType(aType);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_TYPE_RETURN(this, hrc, 0 /*normal*/,*aType);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_TYPE_RETURN(this, hrc, 1 /*hrc exception*/,*aType);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_TYPE_RETURN(this, hrc, 9 /*unhandled exception*/,*aType);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aType=%RU32 hrc=%Rhrc\n", this, "KeyboardLedsChangedEvent::getType", *aType, hrc));
    return hrc;
}

STDMETHODIMP KeyboardLedsChangedEventWrap::COMGETTER(Source)(IEventSource **aSource)
{
    LogRelFlow(("{%p} %s: enter aSource=%p\n", this, "KeyboardLedsChangedEvent::getSource", aSource));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aSource);
        ComTypeOutConverter<IEventSource> TmpSource(aSource);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_SOURCE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getSource(TmpSource.ptr());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_SOURCE_RETURN(this, hrc, 0 /*normal*/,(void *)TmpSource.ptr());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_SOURCE_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_SOURCE_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aSource=%p hrc=%Rhrc\n", this, "KeyboardLedsChangedEvent::getSource", *aSource, hrc));
    return hrc;
}

STDMETHODIMP KeyboardLedsChangedEventWrap::COMGETTER(Waitable)(BOOL *aWaitable)
{
    LogRelFlow(("{%p} %s: enter aWaitable=%p\n", this, "KeyboardLedsChangedEvent::getWaitable", aWaitable));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aWaitable);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_WAITABLE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getWaitable(aWaitable);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_WAITABLE_RETURN(this, hrc, 0 /*normal*/,*aWaitable != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_WAITABLE_RETURN(this, hrc, 1 /*hrc exception*/,*aWaitable != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_WAITABLE_RETURN(this, hrc, 9 /*unhandled exception*/,*aWaitable != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aWaitable=%RTbool hrc=%Rhrc\n", this, "KeyboardLedsChangedEvent::getWaitable", *aWaitable, hrc));
    return hrc;
}

//
// IKeyboardLedsChangedEvent properties
//

STDMETHODIMP KeyboardLedsChangedEventWrap::COMGETTER(NumLock)(BOOL *aNumLock)
{
    LogRelFlow(("{%p} %s: enter aNumLock=%p\n", this, "KeyboardLedsChangedEvent::getNumLock", aNumLock));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aNumLock);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_NUMLOCK_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getNumLock(aNumLock);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_NUMLOCK_RETURN(this, hrc, 0 /*normal*/,*aNumLock != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_NUMLOCK_RETURN(this, hrc, 1 /*hrc exception*/,*aNumLock != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_NUMLOCK_RETURN(this, hrc, 9 /*unhandled exception*/,*aNumLock != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aNumLock=%RTbool hrc=%Rhrc\n", this, "KeyboardLedsChangedEvent::getNumLock", *aNumLock, hrc));
    return hrc;
}

STDMETHODIMP KeyboardLedsChangedEventWrap::COMGETTER(CapsLock)(BOOL *aCapsLock)
{
    LogRelFlow(("{%p} %s: enter aCapsLock=%p\n", this, "KeyboardLedsChangedEvent::getCapsLock", aCapsLock));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aCapsLock);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_CAPSLOCK_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getCapsLock(aCapsLock);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_CAPSLOCK_RETURN(this, hrc, 0 /*normal*/,*aCapsLock != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_CAPSLOCK_RETURN(this, hrc, 1 /*hrc exception*/,*aCapsLock != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_CAPSLOCK_RETURN(this, hrc, 9 /*unhandled exception*/,*aCapsLock != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aCapsLock=%RTbool hrc=%Rhrc\n", this, "KeyboardLedsChangedEvent::getCapsLock", *aCapsLock, hrc));
    return hrc;
}

STDMETHODIMP KeyboardLedsChangedEventWrap::COMGETTER(ScrollLock)(BOOL *aScrollLock)
{
    LogRelFlow(("{%p} %s: enter aScrollLock=%p\n", this, "KeyboardLedsChangedEvent::getScrollLock", aScrollLock));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aScrollLock);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_SCROLLLOCK_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getScrollLock(aScrollLock);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_SCROLLLOCK_RETURN(this, hrc, 0 /*normal*/,*aScrollLock != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_SCROLLLOCK_RETURN(this, hrc, 1 /*hrc exception*/,*aScrollLock != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_GET_SCROLLLOCK_RETURN(this, hrc, 9 /*unhandled exception*/,*aScrollLock != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aScrollLock=%RTbool hrc=%Rhrc\n", this, "KeyboardLedsChangedEvent::getScrollLock", *aScrollLock, hrc));
    return hrc;
}


//
// IEvent methods
//

STDMETHODIMP KeyboardLedsChangedEventWrap::SetProcessed()
{
    LogRelFlow(("{%p} %s:enter\n", this, "KeyboardLedsChangedEvent::setProcessed"));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {



#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_SETPROCESSED_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setProcessed();
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_SETPROCESSED_RETURN(this, hrc, 0 /*normal*/);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_SETPROCESSED_RETURN(this, hrc, 1 /*hrc exception*/);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_SETPROCESSED_RETURN(this, hrc, 9 /*unhandled exception*/);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "KeyboardLedsChangedEvent::setProcessed", hrc));
    return hrc;
}

STDMETHODIMP KeyboardLedsChangedEventWrap::WaitProcessed(LONG aTimeout,
                                                         BOOL *aResult)
{
    LogRelFlow(("{%p} %s:enter aTimeout=%RI32 aResult=%p\n", this, "KeyboardLedsChangedEvent::waitProcessed", aTimeout, aResult));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aResult);


        
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_WAITPROCESSED_ENTER(this, aTimeout);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = waitProcessed(aTimeout,
                                aResult);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_WAITPROCESSED_RETURN(this, hrc, 0 /*normal*/, aTimeout, *aResult != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_WAITPROCESSED_RETURN(this, hrc, 1 /*hrc exception*/, aTimeout, *aResult != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_KEYBOARDLEDSCHANGEDEVENT_WAITPROCESSED_RETURN(this, hrc, 9 /*unhandled exception*/, aTimeout, *aResult != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave aResult=%RTbool hrc=%Rhrc\n", this, "KeyboardLedsChangedEvent::waitProcessed", *aResult, hrc));
    return hrc;
}

//
// IKeyboardLedsChangedEvent methods
//

#ifdef VBOX_WITH_XPCOM
NS_DECL_CLASSINFO(KeyboardLedsChangedEventWrap)
NS_IMPL_THREADSAFE_ISUPPORTS2_CI(KeyboardLedsChangedEventWrap, IKeyboardLedsChangedEvent, IEvent)
#endif // VBOX_WITH_XPCOM

