// ##### ENDFILE "NATNetworkCreationDeletionEventWrap.cpp"


// ##### BEGINFILE "NATNetworkPortForwardEventWrap.cpp"
/** @file
 * VirtualBox API class wrapper code for INATNetworkPortForwardEvent.
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl
 * Generator: src/VBox/Main/idl/apiwrap-server.xsl
 */

/**
 * Copyright (C) 2010-2016 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */

#define LOG_GROUP_MAIN_OVERRIDE LOG_GROUP_MAIN_NATNETWORKPORTFORWARDEVENT

#include "NATNetworkPortForwardEventWrap.h"
#include "Logging.h"
#ifdef VBOX_WITH_DTRACE_R3_MAIN
# include "dtrace/VBoxAPI.h"
#endif

DEFINE_EMPTY_CTOR_DTOR(NATNetworkPortForwardEventWrap)

//
// IEvent properties
//

STDMETHODIMP NATNetworkPortForwardEventWrap::COMGETTER(Type)(VBoxEventType_T *aType)
{
    LogRelFlow(("{%p} %s: enter aType=%p\n", this, "NATNetworkPortForwardEvent::getType", aType));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aType);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_TYPE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getType(aType);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_TYPE_RETURN(this, hrc, 0 /*normal*/,*aType);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_TYPE_RETURN(this, hrc, 1 /*hrc exception*/,*aType);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_TYPE_RETURN(this, hrc, 9 /*unhandled exception*/,*aType);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aType=%RU32 hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::getType", *aType, hrc));
    return hrc;
}

STDMETHODIMP NATNetworkPortForwardEventWrap::COMGETTER(Source)(IEventSource **aSource)
{
    LogRelFlow(("{%p} %s: enter aSource=%p\n", this, "NATNetworkPortForwardEvent::getSource", aSource));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aSource);
        ComTypeOutConverter<IEventSource> TmpSource(aSource);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_SOURCE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getSource(TmpSource.ptr());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_SOURCE_RETURN(this, hrc, 0 /*normal*/,(void *)TmpSource.ptr());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_SOURCE_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_SOURCE_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aSource=%p hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::getSource", *aSource, hrc));
    return hrc;
}

STDMETHODIMP NATNetworkPortForwardEventWrap::COMGETTER(Waitable)(BOOL *aWaitable)
{
    LogRelFlow(("{%p} %s: enter aWaitable=%p\n", this, "NATNetworkPortForwardEvent::getWaitable", aWaitable));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aWaitable);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_WAITABLE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getWaitable(aWaitable);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_WAITABLE_RETURN(this, hrc, 0 /*normal*/,*aWaitable != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_WAITABLE_RETURN(this, hrc, 1 /*hrc exception*/,*aWaitable != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_WAITABLE_RETURN(this, hrc, 9 /*unhandled exception*/,*aWaitable != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aWaitable=%RTbool hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::getWaitable", *aWaitable, hrc));
    return hrc;
}

//
// INATNetworkChangedEvent properties
//

STDMETHODIMP NATNetworkPortForwardEventWrap::COMGETTER(NetworkName)(BSTR *aNetworkName)
{
    LogRelFlow(("{%p} %s: enter aNetworkName=%p\n", this, "NATNetworkPortForwardEvent::getNetworkName", aNetworkName));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aNetworkName);
        BSTROutConverter TmpNetworkName(aNetworkName);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_NETWORKNAME_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getNetworkName(TmpNetworkName.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_NETWORKNAME_RETURN(this, hrc, 0 /*normal*/,TmpNetworkName.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_NETWORKNAME_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_NETWORKNAME_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aNetworkName=%ls hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::getNetworkName", *aNetworkName, hrc));
    return hrc;
}

//
// INATNetworkAlterEvent properties
//

STDMETHODIMP NATNetworkPortForwardEventWrap::COMGETTER(MidlDoesNotLikeEmptyInterfaces)(BOOL *aMidlDoesNotLikeEmptyInterfaces)
{
#if 0 /* This is a dummy attribute */
    LogRelFlow(("{%p} %s: enter aMidlDoesNotLikeEmptyInterfaces=%p\n", this, "NATNetworkPortForwardEvent::getMidlDoesNotLikeEmptyInterfaces", aMidlDoesNotLikeEmptyInterfaces));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aMidlDoesNotLikeEmptyInterfaces);
        
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getMidlDoesNotLikeEmptyInterfaces(aMidlDoesNotLikeEmptyInterfaces);
        }
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
    }

    LogRelFlow(("{%p} %s: leave *aMidlDoesNotLikeEmptyInterfaces=%RTbool hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::getMidlDoesNotLikeEmptyInterfaces", *aMidlDoesNotLikeEmptyInterfaces, hrc));
    return hrc;
#else  /* dummy attribute */
    NOREF(aMidlDoesNotLikeEmptyInterfaces);
    return E_FAIL;
#endif /* dummy attribute */
}

//
// INATNetworkPortForwardEvent properties
//

STDMETHODIMP NATNetworkPortForwardEventWrap::COMGETTER(Create)(BOOL *aCreate)
{
    LogRelFlow(("{%p} %s: enter aCreate=%p\n", this, "NATNetworkPortForwardEvent::getCreate", aCreate));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aCreate);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_CREATE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getCreate(aCreate);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_CREATE_RETURN(this, hrc, 0 /*normal*/,*aCreate != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_CREATE_RETURN(this, hrc, 1 /*hrc exception*/,*aCreate != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_CREATE_RETURN(this, hrc, 9 /*unhandled exception*/,*aCreate != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aCreate=%RTbool hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::getCreate", *aCreate, hrc));
    return hrc;
}

STDMETHODIMP NATNetworkPortForwardEventWrap::COMGETTER(Ipv6)(BOOL *aIpv6)
{
    LogRelFlow(("{%p} %s: enter aIpv6=%p\n", this, "NATNetworkPortForwardEvent::getIpv6", aIpv6));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aIpv6);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_IPV6_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getIpv6(aIpv6);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_IPV6_RETURN(this, hrc, 0 /*normal*/,*aIpv6 != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_IPV6_RETURN(this, hrc, 1 /*hrc exception*/,*aIpv6 != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_IPV6_RETURN(this, hrc, 9 /*unhandled exception*/,*aIpv6 != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aIpv6=%RTbool hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::getIpv6", *aIpv6, hrc));
    return hrc;
}

STDMETHODIMP NATNetworkPortForwardEventWrap::COMGETTER(Name)(BSTR *aName)
{
    LogRelFlow(("{%p} %s: enter aName=%p\n", this, "NATNetworkPortForwardEvent::getName", aName));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aName);
        BSTROutConverter TmpName(aName);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_NAME_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getName(TmpName.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_NAME_RETURN(this, hrc, 0 /*normal*/,TmpName.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_NAME_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_NAME_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aName=%ls hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::getName", *aName, hrc));
    return hrc;
}

STDMETHODIMP NATNetworkPortForwardEventWrap::COMGETTER(Proto)(NATProtocol_T *aProto)
{
    LogRelFlow(("{%p} %s: enter aProto=%p\n", this, "NATNetworkPortForwardEvent::getProto", aProto));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aProto);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_PROTO_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getProto(aProto);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_PROTO_RETURN(this, hrc, 0 /*normal*/,*aProto);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_PROTO_RETURN(this, hrc, 1 /*hrc exception*/,*aProto);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_PROTO_RETURN(this, hrc, 9 /*unhandled exception*/,*aProto);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aProto=%RU32 hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::getProto", *aProto, hrc));
    return hrc;
}

STDMETHODIMP NATNetworkPortForwardEventWrap::COMGETTER(HostIp)(BSTR *aHostIp)
{
    LogRelFlow(("{%p} %s: enter aHostIp=%p\n", this, "NATNetworkPortForwardEvent::getHostIp", aHostIp));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aHostIp);
        BSTROutConverter TmpHostIp(aHostIp);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_HOSTIP_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getHostIp(TmpHostIp.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_HOSTIP_RETURN(this, hrc, 0 /*normal*/,TmpHostIp.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_HOSTIP_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_HOSTIP_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aHostIp=%ls hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::getHostIp", *aHostIp, hrc));
    return hrc;
}

STDMETHODIMP NATNetworkPortForwardEventWrap::COMGETTER(HostPort)(LONG *aHostPort)
{
    LogRelFlow(("{%p} %s: enter aHostPort=%p\n", this, "NATNetworkPortForwardEvent::getHostPort", aHostPort));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aHostPort);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_HOSTPORT_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getHostPort(aHostPort);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_HOSTPORT_RETURN(this, hrc, 0 /*normal*/,*aHostPort);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_HOSTPORT_RETURN(this, hrc, 1 /*hrc exception*/,*aHostPort);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_HOSTPORT_RETURN(this, hrc, 9 /*unhandled exception*/,*aHostPort);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aHostPort=%RI32 hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::getHostPort", *aHostPort, hrc));
    return hrc;
}

STDMETHODIMP NATNetworkPortForwardEventWrap::COMGETTER(GuestIp)(BSTR *aGuestIp)
{
    LogRelFlow(("{%p} %s: enter aGuestIp=%p\n", this, "NATNetworkPortForwardEvent::getGuestIp", aGuestIp));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aGuestIp);
        BSTROutConverter TmpGuestIp(aGuestIp);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_GUESTIP_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getGuestIp(TmpGuestIp.str());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_GUESTIP_RETURN(this, hrc, 0 /*normal*/,TmpGuestIp.str().c_str());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_GUESTIP_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_GUESTIP_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aGuestIp=%ls hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::getGuestIp", *aGuestIp, hrc));
    return hrc;
}

STDMETHODIMP NATNetworkPortForwardEventWrap::COMGETTER(GuestPort)(LONG *aGuestPort)
{
    LogRelFlow(("{%p} %s: enter aGuestPort=%p\n", this, "NATNetworkPortForwardEvent::getGuestPort", aGuestPort));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aGuestPort);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_GUESTPORT_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getGuestPort(aGuestPort);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_GUESTPORT_RETURN(this, hrc, 0 /*normal*/,*aGuestPort);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_GUESTPORT_RETURN(this, hrc, 1 /*hrc exception*/,*aGuestPort);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_GET_GUESTPORT_RETURN(this, hrc, 9 /*unhandled exception*/,*aGuestPort);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aGuestPort=%RI32 hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::getGuestPort", *aGuestPort, hrc));
    return hrc;
}


//
// IEvent methods
//

STDMETHODIMP NATNetworkPortForwardEventWrap::SetProcessed()
{
    LogRelFlow(("{%p} %s:enter\n", this, "NATNetworkPortForwardEvent::setProcessed"));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {



#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_SETPROCESSED_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setProcessed();
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_SETPROCESSED_RETURN(this, hrc, 0 /*normal*/);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_SETPROCESSED_RETURN(this, hrc, 1 /*hrc exception*/);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_SETPROCESSED_RETURN(this, hrc, 9 /*unhandled exception*/);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::setProcessed", hrc));
    return hrc;
}

STDMETHODIMP NATNetworkPortForwardEventWrap::WaitProcessed(LONG aTimeout,
                                                           BOOL *aResult)
{
    LogRelFlow(("{%p} %s:enter aTimeout=%RI32 aResult=%p\n", this, "NATNetworkPortForwardEvent::waitProcessed", aTimeout, aResult));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aResult);


        
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_WAITPROCESSED_ENTER(this, aTimeout);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = waitProcessed(aTimeout,
                                aResult);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_WAITPROCESSED_RETURN(this, hrc, 0 /*normal*/, aTimeout, *aResult != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_WAITPROCESSED_RETURN(this, hrc, 1 /*hrc exception*/, aTimeout, *aResult != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_NATNETWORKPORTFORWARDEVENT_WAITPROCESSED_RETURN(this, hrc, 9 /*unhandled exception*/, aTimeout, *aResult != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave aResult=%RTbool hrc=%Rhrc\n", this, "NATNetworkPortForwardEvent::waitProcessed", *aResult, hrc));
    return hrc;
}

//
// INATNetworkChangedEvent methods
//

//
// INATNetworkAlterEvent methods
//

//
// INATNetworkPortForwardEvent methods
//

#ifdef VBOX_WITH_XPCOM
NS_DECL_CLASSINFO(NATNetworkPortForwardEventWrap)
NS_IMPL_THREADSAFE_ISUPPORTS4_CI(NATNetworkPortForwardEventWrap, INATNetworkPortForwardEvent, INATNetworkAlterEvent, INATNetworkChangedEvent, IEvent)
#endif // VBOX_WITH_XPCOM

